<template lang="pug">
.container
  div.md-scrollbar
    user-list(:userList="favouriteUsers")
    label(v-if="!favouriteUsers.length") No hay usuarios favoritos
  md-toolbar
    label Exportar en CSV
    md-button.md-icon-button.md-primary(v-if="favouriteUsers.length" @click="csvExport()")
      md-icon.fa.fa-save
    md-button.md-icon-button.md-disabled.disabled(v-else)
      md-icon.fa.fa-save
  md-toolbar.margin-top-2
    md-field
      label Nombre de lista
      md-input(v-model="listName")
    label Guardar lista
    md-button.right-button.md-icon-button.md-primary(@click="saveListAPI()")
      md-icon.fa.fa-paper-plane
  md-snackbar(md-position="center" :md-duration="2000" :md-active.sync="showSnackbar" md-persistent)
    span {{alertMessage}}
    md-button.md-primary(@click="showSnackbar = false") Vale
</template>

<script>
import UserList from '../components/UserList'
export default {
  name: 'Vista3',
  components: { UserList },
  data () {
    return {
        listName: '',
        alertMessage: '',
        showSnackbar: false
    }
  },
  computed: {
    favouriteUsers () {
      return this.$store.state.favouriteUsers
    }
  },
  methods: {
    csvExport() {
      const csvHeader = "data:text/csv;charset=utf-8,";
      const parsedExportList = this.favouriteUsers.map(x => {
        return {
          genero: this.$t('gender.'+x.gender),
          nombre: `${x.name.first} ${x.name.last}`,
          email: x.email,
          nacionalidad: `${x.nat} - ${this.$t('countries.'+x.nat)}`,
          fecha_nacimiento: new Date(x.dob.date).toLocaleDateString('es-ES'),
          fecha_registro: new Date(x.registered.date).toLocaleDateString('es-ES')
        }
      })
      const csvContent = [
        Object.keys(parsedExportList[0]).join(";"),
        ...parsedExportList.map(item => Object.values(item).join(";"))
      ].join("\n").replace(/(^\[)|(\]$)/gm, "");
      const data = encodeURI(csvHeader+csvContent);
      const link = document.createElement("a");
      link.setAttribute("href", data);
      link.setAttribute("download", "favouriteUsers.csv");
      link.click();
    },
    saveListAPI() {
      if (!this.listName) {
        this.alertMessage = 'Es necesario introducir un nombre.'
        this.showSnackbar = true;
        return false;
      }
      if (!this.favouriteUsers.length) {
        this.alertMessage = 'La lista está vacía.'
        this.showSnackbar = true;
        return false;
      }
      this.$favouritesService.postList({name: this.listName, userList: this.favouriteUsers}).then((err, res) => {
        this.alertMessage = 'Se ha guardado la lista correctamente';
        this.showSnackbar = true;
      }).catch(err => {
        this.alertMessage = 'Ha ocurrido un error. ' + err.response.data.response.message;
        this.showSnackbar = true;
      });
    }
  }
}
</script>
<style scoped>
.md-scrollbar {
  max-height: 65vh;
  min-height: 65vh;
  padding-right: 0 !important;
  overflow: auto;
}
::-webkit-scrollbar {
  width: 0px;
  background: transparent; /* make scrollbar transparent */
}
.margin-top-2 {
  margin-top: 10px;
}
</style>
